unit Quicksort;

interface

procedure QuicksortIntegers(var A : array of integer);

implementation

procedure QSIntegers(var A  : array of integer;
                     aFirst : integer;
                     aLast  : integer);
var
  L, R  : integer;
  Pivot : integer;
  Temp  : integer;
begin
  {while there are at least two items to sort}
  while (aFirst < aLast) do begin
    {the pivot is the middle item}
    Pivot := A[(aFirst+aLast) div 2];
    {set indexes and partition}
    L := pred(aFirst);
    R := succ(aLast);
    while true do begin
      repeat dec(R); until (A[R] <= Pivot);
      repeat inc(L); until (A[L] >= Pivot);
      if (L >= R) then Break;
      Temp := A[L];
      A[L] := A[R];
      A[R] := Temp;
    end;
    {quicksort the first subfile}
    if (aFirst < R) then
      QSIntegers(A, aFirst, R);
    {quicksort the second subfile - recursion removal}
    aFirst := succ(R);
  end;
end;

procedure QuicksortIntegers(var A : array of integer);
begin
  QSIntegers(A, 0, length(A) - 1);
end;

end.
